/* MASTER SETTINGS MENU part of RIDDLE BOX

   Open/close compartment and set/reset progress
   
   For more information please visit: https://www.instructables.com/id/Arduino-Riddlebox

   Licence: CC-BY-SA
   https://creativecommons.org/licenses/by-sa/2.5/
   //th 01/2018
*/
void advanced() {

  //Variable initialisation
  byte i = 0;
  byte prog = 0;
  boolean passed = false;
  boolean out = false;
  boolean doorOpen = false;
  
  //Replace passwd with a password of your choice
  char passwd[5] = {"2582"};
  char entry[5] = {"0000"};

  //Password screen
  lcd.clear();
  lcd.setCursor(2, 0);
  lcd.print("MASTER SETTINGS:");
  lcd.setCursor(6, 2);
  lcd.print("=[    ]=");
  do {
    char key = kpd.getKey();
    if (key) {
      entry[i] = key;
      lcd.setCursor(8 + i , 2);
      lcd.print("*");
      i++;
    }
    if (i == 4) {
      delay(250);
      if (strcmp(entry, passwd) == 0) {
        lcd.setCursor(7, 3);
        lcd.print("CORRECT");
        delay(1000);
        passed = true;
      } else {
        lcd.setCursor(6, 3);
        lcd.print("INCORRECT");
        delay(1000);
        lcd.setCursor(6, 3);
        lcd.print("         ");
        lcd.setCursor(8, 2);
        lcd.print("    ");
        //Clears the answer array by writing zeros, working backwards from the last (current) array element
        while (i != 0) {
          entry[i--] = 0;
        }
      }
    }
  } while (passed == false);

  //Main settings menu
main:
  delay(250);
  lcd.clear();
  lcd.home();
  lcd.print("A: Progress Setting");
  lcd.setCursor(0, 1);
  lcd.print("B: Open Compartment");
  lcd.setCursor(0, 3);
  lcd.print("D: Exit");
  do {
    char key = kpd.getKey();
    if (key) {
      if (key == 'A') {
        goto item1;
      } else if (key == 'B') {
        goto item2;
      } else if (key == 'D') {
        break;;
      }
    }
  } while (true);
  return;

  //Manual progress setting menu
item1:
  delay(250);
  lcd.clear();
  lcd.setCursor(2, 0);
  lcd.print("PROGRESS SETTING");
  lcd.setCursor(0, 1);
  lcd.print("A: Manual Progress");
  lcd.setCursor(0, 2);
  lcd.print("B: Reset Progress");
  lcd.setCursor(0, 3);
  lcd.print("D: Main Menu");
  do {
    char key = kpd.getKey();
    if (key) {
      if (key == 'A') {
        goto item11;
      } else if (key == 'B') {
        goto item12;
      } else if (key == 'D') {
        goto main;
      }
    }
  } while (true);

  //Manual progress settings
item11:
  delay(250);
  lcd.clear();
  lcd.setCursor(4, 0);
  lcd.print("SET PROGRESS");
  lcd.setCursor(6, 2);
  lcd.print("- [  ] +");
  lcd.setCursor(0, 3);
  lcd.print("D: Cancel");
  lcd.setCursor(15, 3);
  lcd.print("A: OK");
  do {
    char key = kpd.getKey();
    if (key) {
      if (key == '#' && prog < 10) {
        prog++;
      } else if (key == '*' && prog > 0) {
        prog--;
      } else if (key == 'A') {
        progress = prog;
        EEPROM.update(eeAddr, progress);
        lcd.clear();
        lcd.setCursor(4, 1);
        lcd.print("PROGRESS SET");
        delay(1500);
        goto item1;
      } else if (key == 'D') {
        goto item1;
      }
      lcd.setCursor(9, 2);
      lcd.print("  ");
      lcd.setCursor(9, 2);
      lcd.print(prog);
    }
  } while (true);

  //Progress reset confirmation
item12:
  delay(250);
  out = false;
  lcd.clear();
  lcd.setCursor(4, 0);
  lcd.print("CONFIRM RESET");
  lcd.setCursor(0, 3);
  lcd.print("D: NO");
  lcd.setCursor(14, 3);
  lcd.print("A: YES");
  do {
    char key = kpd.getKey();
    if (key) {
      if (key == 'A') {
        progress = 0;
        EEPROM.update(eeAddr, progress);
        lcd.clear();
        lcd.setCursor(3, 1);
        lcd.print("PROGRESS RESET");
        delay(2000);
        goto main;
      } else if (key == 'D') {
        goto item1;
      }
    }
  } while (out == false);

  // Manual copartment control
item2:
  delay(250);
  out = false;
  lcd.clear();
  lcd.setCursor(2, 0);
  lcd.print("COMPARTMENT DOOR");
  lcd.setCursor(0, 1);
  lcd.print("A: Open/Close");
  lcd.setCursor(0, 3);
  lcd.print("D: Main Menu");
  do {
    char key = kpd.getKey();
    if (key) {
      if (key == 'A') {
        //servo soor control
        if (doorOpen == false) {
          //open servo
          lockServo.write(90);
          delay(500);
          doorServo.write(10);
          //Serial readout or debugging
          //Serial.println("door opened");
          doorOpen = true;
        } else if (doorOpen == true) {
          doorServo.write(90);
          delay(500);
          lockServo.write(10);
          //Serial.println("door closed");
          doorOpen = false;
        }
      } else if (key == 'D') {
        goto main;
      }
    }
  } while (out == false);

  delay(750);
}
