/* PATIENCE RIDDLE part of RIDDLE BOX

   A timer runs for 5 mins and is reset and doubbled for each turn of the key
   Due to the nature of the timer variable, turning the key often enough (25-50) causes it to overflow, thus effectively ending the timer instantly.

   For more information please visit: https://www.instructables.com/id/Arduino-Riddlebox

   Licence: CC-BY-SA
   https://creativecommons.org/licenses/by-sa/2.5/
   //th 01/2018
*/
void patience() {
  byte n = 0;
item1:
  delay(250);
  lcd.clear();
  lcd.setCursor(6, 0);
  lcd.print("RIDDLE 9:");
  lcd.setCursor(6, 2);
  lcd.print("PATIENCE");
  lcd.setCursor(18, 3);
  lcd.print(">>");
  do {
    char key = kpd.getKey();
    if (key) {
      if (key == '#') {
        break;
      }
    }
  } while (true);
item2:
  delay(250);
  lcd.clear();
  lcd.setCursor(0, 1);
  lcd.print("Don't turn the key!");
  boolean solved = false;
  long startTime = millis();
  //Set timer length here in miliseconds
  //Example calculation: 5min * 60s = 300s * 1000ms = 300000ms
  long timer = 300000;
  switchState1 = digitalRead(keySwitch1);
  switchState2 = digitalRead(keySwitch2);
  do {
    oldSwitchState1 = switchState1;
    oldSwitchState2 = switchState2;
    switchState1 = digitalRead(keySwitch1);
    switchState2 = digitalRead(keySwitch2);
    if (millis() - startTime >= timer) {
      solved = true;
    } else if (switchState1 != oldSwitchState1 || switchState2 != oldSwitchState2) {
      n++;
      switch (n) {
        case 1:
          lcd.clear();
          lcd.home();
          lcd.print("Hey! I told you not");
          lcd.setCursor(0, 1);
          lcd.print("to turn the key!");
          break;
        case 2:
          lcd.clear();
          lcd.home();
          lcd.print("Seriously, stop it!");
          break;
        case 3:
          lcd.clear();
          lcd.home();
          lcd.print("You're only making");
          lcd.setCursor(0, 1);
          lcd.print("it worse for");
          lcd.setCursor(0, 2);
          lcd.print("yourself");
          break;
      }
      timer = timer * 2;
      startTime = millis();
      Serial.println(startTime);
      Serial.println(timer);
      delay(500);
    }
  } while (solved == false);
  progress++;
}
